/*==================================================*/
/* Configuration for SADP. Edit to suit your needs. */
/*==================================================*/


/* Comment out the following line to disable spectrum analyzer */

#define DSP_SUPPORT

/* Comment out the following line to disable mixer support */

#define MIXER_SUPPORT 

/* Comment or uncomment the next line depending on
   whether you need support of SCSI CDROM. As the
   effect of this, the program will issue a SCSI
   specific command for probing CD, that helps to
   avoid messages comming from the driver. For 
   other drives it simply has no effect */

#define SCSI_SUPPORT

/* This will invoke the universal CD command set for
   probing if media is present (listed in ucdrom.h)
   Though this does not not seems to work with  all
   three drivers, I tested to program with, it may
   be all right test with your driver.
*/

#define UCDROM_SUPPORT

/* Defines default Data base */
#define DEFAULT_DB_PATH   "~/.xcddbase"

/* Sets the default probing mode (0-disabled, 1-enabled) */
#define DEFAULT_PROBE   1


/* Sets the default auto-play mode (0 - off, 1-on) */
#define DEFAULT_AUTOPLAY   0

/* Sets the default loop play (0-off, 1-on) */
#define DEFAULT_LOOPPLAY   0

/* Sets default auto-save options for settings and data */
#define DEFAULT_SAVE_SETTINGS 0
#define DEFAULT_SAVE_DATA 1


/* Time required to get the full disk speed, after it started (sec) */
#define TIME_OUT_START   3


/* Time required to change position of a currently playing disk (sec) */
#define TIME_OUT_REPOSITION  0


/* Time required to close the disk tray (sec) */
#define TIME_OUT_LOAD   1


/* Time between frame shifting in HELP PLAY (millisec)  */
#define TIME_OUT_HELP_ADVANCE   100

/* Duration of track play in INTRO mode (sec) */
#define INTRO_DURATION_SEC 20

/* Duration used in FORWARD and BACK commands (sec) */
#define STEP_DISCRETE  15

/* Default background colour for console version */
/* 0 - black, 1 - red,     2 - green, 3 - brown, */
/* 4 - blue,  5 - magenta, 6 - cyan,  7 -grey    */
#define DEFAULT_BACKGROUND_COLOUR 4

/* Default colours for X version */
/* You can use any X-type colour name - see XLookupColor man page for details */
#define DEFAULT_XCOLOUR_BKGR     "#0000FF"   /* Background (blue) */
#define DEFAULT_XCOLOUR_FTOP     "#FFE79B"   /* Top foreground (wheat) */
#define DEFAULT_XCOLOUR_FBOTTOM  "#FFFFFF"   /* Bottom foreground (white) */

/* Default spectrum bar width */
#define DEFAULT_BAR_WIDTH   8

/* Default oscilloscope settings */
#define DEFAULT_OBTURATE   0
#define DEFAULT_PIX_WIDTH  3
#define DEFAULT_PIX_HEIGHT 3
